Scriptname HDTSextoys extends Quest

SexLabFramework Property SexLab Auto
Armor[] Property HDT_Toys Auto
sslBaseAnimation[] HDT_Anims1
sslBaseAnimation[] HDT_Anims2
Armor[] HDT_Armor

Event OnInit()
	HDTToysRegister()
EndEvent

Function HDTSextoyEquip(int tid, bool HasPlayer)
EndFunction
 
Function HDTSextoyUnEquip(int tid, bool HasPlayer)
EndFunction

Function HDTToysRegister()
	HDT_Anims1 = SexLab.GetAnimationsByTag(1, "SexToy", "Vaginal")
	HDT_Anims2 = SexLab.GetAnimationsByTag(2, "SexToy", "Vaginal")
	If HDT_Anims1.Length + HDT_Anims2.Length == 0
		Debug.Notification("There are no sex toy animations installed.")
		Return
	Else
		Debug.Notification("Initializing ... " + HDT_Anims1.Length + " solo + " + HDT_Anims2.Length + " paired sex toy animations found.")
		RegisterForModEvent("HookStageStart", "HDTSextoyEquip")
		RegisterForModEvent("HookAnimationEnd", "HDTSextoyUnEquip")
		GoToState("HDTSextoysOn")
	EndIf
EndFunction

Function HDTToyRemove(Actor Act, Armor Arm)
	If Arm != None && HDT_Toys.Find(Arm) >= 0
		Act.UnequipItem(Arm, false, true)		
		Utility.Wait(0.5)
		Act.RemoveItem(Arm, 1, true)
		Act.QueueNiNodeUpdate()
	EndIf
EndFunction

State HDTSextoysOn
;Event OnBeginState()
;	Debug.Notification("HDTSextoys active.")
;EndEvent

Event HDTSextoyEquip(int tid, bool HasPlayer)
	sslThreadController HDT_thread = SexLab.GetController(tid)
	Actor[] HDT_Pos = HDT_thread.Positions
	sslBaseAnimation HDT_Anim = HDT_thread.Animation
	int HDT_Stage = HDT_thread.Stage
	int m = HDT_Anims1.Find(HDT_Anim)
	int n = HDT_Anims2.Find(HDT_Anim)
	If HDT_Pos && HDT_Pos[0]
		HDT_Armor[0] = HDT_Pos[0].GetWornForm(0x08000000) as Armor
	;	Debug.Notification("Equipped sex toy: " + HDT_Armor[0].GetName())
		If n >= 0
	;		JsonUtil.StringListAdd("HDT_Sextoys.json", "anim_list", HDT_Anim.Name, false)
	;		JsonUtil.SetPathIntValue("HDT_Sextoys.json", ".pair_anims."+"."+HDT_Anim.Name+"."+".stage "+HDT_Stage+"."+".ActorNr.", 1)
	;		JsonUtil.SetPathIntValue("HDT_Sextoys.json", ".pair_anims."+"."+HDT_Anim.Name+"."+".stage "+HDT_Stage+"."+".ToyNr.", 9)
	;		JsonUtil.Save("HDT_Sextoys.json")
			If JsonUtil.StringListHas("HDT_Sextoys.json", "anim_list", HDT_Anim.Name)
				HDT_Armor[1] = HDT_Pos[1].GetWornForm(0x08000000) as Armor
				int a = JsonUtil.GetPathIntValue("HDT_Sextoys.json", ".pair_anims."+"."+HDT_Anim.Name+"."+".stage "+HDT_Stage+"."+".ActorNr.")
				If a < 0
					HDTToyRemove(HDT_Pos[0], HDT_Armor[0])
					HDTToyRemove(HDT_Pos[1], HDT_Armor[1])
				Else
					int b = JsonUtil.GetPathIntValue("HDT_Sextoys.json", ".pair_anims."+"."+HDT_Anim.Name+"."+".stage "+HDT_Stage+"."+".ToyNr.")
					int c = math.abs((a as float) - 1.0) as int
	;				Debug.Notification("actor " + a + " and toy " + b + " and abs " + c)
					HDTToyRemove(HDT_Pos[c], HDT_Armor[c])
					If HDT_Armor[a] != HDT_Toys[b]
						HDTToyRemove(HDT_Pos[a], HDT_Armor[a])
						HDT_Pos[a].EquipItem(HDT_Toys[b], false, true)
						HDT_Pos[a].QueueNiNodeUpdate()
					EndIf
				EndIf
			EndIf
		ElseIf m >= 0
			int i = 0
			While i < 9
				If HDT_Anim.Name == HDT_Toys[i].GetName() && HDT_Armor[0] != HDT_Toys[i]
					HDTToyRemove(HDT_Pos[0], HDT_Armor[0])
					HDT_Pos[0].EquipItem(HDT_Toys[i], false, true)
					HDT_Pos[0].QueueNiNodeUpdate()
				Endif
				i += 1
			EndWhile
		Else
			HDTToyRemove(HDT_Pos[0], HDT_Armor[0])
			If HDT_Pos.Length > 1
				HDT_Armor[1] = HDT_Pos[1].GetWornForm(0x08000000) as Armor
				HDTToyRemove(HDT_Pos[1], HDT_Armor[1])
			EndIf
		EndIf
	EndIf
EndEvent

Event HDTSextoyUnEquip(int tid, bool HasPlayer)
	sslThreadController HDT_thread = SexLab.GetController(tid)
	Actor[] HDT_Pos = HDT_thread.Positions
	HDT_Armor[0] = HDT_Pos[0].GetWornForm(0x08000000) as Armor
	HDTToyRemove(HDT_Pos[0], HDT_Armor[0])
	If HDT_Pos.Length > 1
		HDT_Armor[1] = HDT_Pos[1].GetWornForm(0x08000000) as Armor
		HDTToyRemove(HDT_Pos[1], HDT_Armor[1])
	EndIf
EndEvent
EndState